"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lint = void 0;
const chalk_1 = __importDefault(require("chalk"));
const effect_1 = require("effect");
const lint_semver_ranges_1 = require("../bin-lint-semver-ranges/lint-semver-ranges");
const list_mismatches_1 = require("../bin-list-mismatches/list-mismatches");
const tag_1 = require("../config/tag");
const default_error_handlers_1 = require("../error-handlers/default-error-handlers");
const get_context_1 = require("../get-context");
const io_1 = require("../io");
const exit_if_invalid_1 = require("../io/exit-if-invalid");
const with_logger_1 = require("../lib/with-logger");
function lint({ io, cli, errorHandlers = default_error_handlers_1.defaultErrorHandlers }) {
    return (0, effect_1.pipe)((0, get_context_1.getContext)({ io, cli, errorHandlers }), effect_1.Effect.tap(() => effect_1.Effect.logInfo((0, chalk_1.default) `{yellow Versions}`)), effect_1.Effect.flatMap((ctx) => (0, list_mismatches_1.pipeline)(ctx, io, errorHandlers)), effect_1.Effect.tap(() => effect_1.Effect.logInfo((0, chalk_1.default) `{yellow Semver Ranges}`)), effect_1.Effect.flatMap((ctx) => (0, lint_semver_ranges_1.pipeline)(ctx, io, errorHandlers)), effect_1.Effect.flatMap(exit_if_invalid_1.exitIfInvalid), effect_1.Effect.provide((0, effect_1.pipe)(effect_1.Context.empty(), effect_1.Context.add(tag_1.CliConfigTag, cli), effect_1.Context.add(io_1.IoTag, io))), with_logger_1.withLogger);
}
exports.lint = lint;
