import { Data, Effect } from 'effect';
import type { Ctx } from '../get-context';
import { NameAndVersionPropsStrategy } from '../strategy/name-and-version-props';
import { NamedVersionStringStrategy } from '../strategy/named-version-string';
import { UnnamedVersionStringStrategy } from '../strategy/unnamed-version-string';
import { VersionsByNameStrategy } from '../strategy/versions-by-name';
export declare namespace Strategy {
    type Any = NameAndVersionPropsStrategy | NamedVersionStringStrategy | UnnamedVersionStringStrategy | VersionsByNameStrategy;
}
declare const InvalidCustomTypeError_base: new <A extends Record<string, any> = {}>(args: import("effect/Types").Equals<Omit<A, keyof import("effect/Equal").Equal>, {}> extends true ? void : { readonly [P in keyof A as P extends "_tag" | keyof import("effect/Equal").Equal ? never : P]: A[P]; }) => Data.Data<Readonly<A> & {
    readonly _tag: "InvalidCustomTypeError";
}>;
export declare class InvalidCustomTypeError extends InvalidCustomTypeError_base<{
    readonly config: unknown;
    readonly reason: string;
}> {
}
export declare function getCustomTypes({ rcFile, }: Ctx['config']): Effect.Effect<never, InvalidCustomTypeError, Strategy.Any[]>;
export {};
