/** Single source of truth, intended to aid testing or to override */
export declare const CWD: string;
/** Single source of truth for icons used in output */
export declare const ICON: {
    readonly banned: "⦸";
    readonly cross: "✘";
    readonly debug: "?";
    readonly info: "i";
    readonly panic: "!";
    readonly rightArrow: "→";
    readonly skip: "-";
    readonly tick: "✓";
};
export declare const RANGE: {
    readonly ANY: "*";
    readonly EXACT: "";
    readonly GT: ">";
    readonly GTE: ">=";
    readonly LOOSE: ".x";
    readonly LT: "<";
    readonly LTE: "<=";
    readonly MINOR: "^";
    readonly PATCH: "~";
    readonly WORKSPACE: "workspace:";
};
export declare const INTERNAL_TYPES: readonly ["dev", "local", "overrides", "peer", "pnpmOverrides", "prod", "resolutions"];
export declare const DEFAULT_CONFIG: {
    customTypes: {
        dev: {
            strategy: "versionsByName";
            path: string;
        };
        local: {
            strategy: "name~version";
            namePath: string;
            path: string;
        };
        overrides: {
            strategy: "versionsByName";
            path: string;
        };
        peer: {
            strategy: "versionsByName";
            path: string;
        };
        pnpmOverrides: {
            strategy: "versionsByName";
            path: string;
        };
        prod: {
            strategy: "versionsByName";
            path: string;
        };
        resolutions: {
            strategy: "versionsByName";
            path: string;
        };
    };
    dependencyTypes: string[];
    filter: string;
    indent: string;
    semverGroups: never[];
    sortAz: string[];
    sortFirst: string[];
    source: string[];
    versionGroups: never[];
};
