"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.newlines = exports.writeIfChanged = void 0;
const chalk_1 = __importDefault(require("chalk"));
const effect_1 = require("effect");
const os_1 = require("os");
const get_indent_1 = require("../config/get-indent");
const constants_1 = require("../constants");
const write_file_sync_1 = require("./write-file-sync");
function writeIfChanged(ctx) {
    return (0, effect_1.pipe)(effect_1.Effect.all(ctx.packageJsonFiles.map((file) => (0, effect_1.pipe)(effect_1.Effect.Do, effect_1.Effect.bind('nextJson', () => toJson(file)), effect_1.Effect.bind('hasChanged', ({ nextJson }) => effect_1.Effect.succeed(file.jsonFile.json !== nextJson)), effect_1.Effect.flatMap(({ hasChanged, nextJson }) => hasChanged
        ? (0, effect_1.pipe)((0, write_file_sync_1.writeFileSync)(file.jsonFile.filePath, nextJson), effect_1.Effect.flatMap(() => effect_1.Effect.logInfo((0, chalk_1.default) `{green ${constants_1.ICON.tick}} ${file.jsonFile.shortPath}`)))
        : effect_1.Effect.logInfo((0, chalk_1.default) `{dim ${constants_1.ICON.skip} ${file.jsonFile.shortPath}}`))))), effect_1.Effect.map(() => ctx));
    function toJson(file) {
        const contents = file.jsonFile.contents;
        const indent = (0, get_indent_1.getIndent)(ctx.config);
        const EOL = exports.newlines.detect(file.jsonFile.json);
        const source = `${JSON.stringify(contents, null, indent)}${EOL}`;
        return effect_1.Effect.succeed(exports.newlines.fix(source, EOL));
    }
}
exports.writeIfChanged = writeIfChanged;
const CR = '\r';
const CRLF = '\r\n';
const LF = '\n';
exports.newlines = {
    detect(source) {
        const cr = source.split(CR).length;
        const lf = source.split(LF).length;
        const crlf = source.split(CRLF).length;
        if (cr + lf === 0)
            return os_1.EOL;
        if (crlf === cr && crlf === lf)
            return CRLF;
        if (cr > lf)
            return CR;
        return LF;
    },
    fix(source, lineEnding) {
        return source.replace(/\r\n|\n|\r/g, lineEnding);
    },
};
