import type { Instance } from '../get-instances/instance';
import { type Delete } from '../version-group/lib/delete';
import { AliasSpecifier } from './alias';
import { DeleteSpecifier } from './delete';
import { FileSpecifier } from './file';
import { HostedGitSpecifier } from './hosted-git';
import { RangeSpecifier } from './range';
import { TagSpecifier } from './tag';
import { UnsupportedSpecifier } from './unsupported';
import { UrlSpecifier } from './url';
import { VersionSpecifier } from './version';
import { WorkspaceProtocolSpecifier } from './workspace-protocol';
export declare namespace Specifier {
    const Alias: typeof AliasSpecifier;
    const Delete: typeof DeleteSpecifier;
    const File: typeof FileSpecifier;
    const HostedGit: typeof HostedGitSpecifier;
    const Range: typeof RangeSpecifier;
    const Tag: typeof TagSpecifier;
    const Unsupported: typeof UnsupportedSpecifier;
    const Url: typeof UrlSpecifier;
    const Version: typeof VersionSpecifier;
    const WorkspaceProtocol: typeof WorkspaceProtocolSpecifier;
    type Any = AliasSpecifier | DeleteSpecifier | FileSpecifier | HostedGitSpecifier | RangeSpecifier | TagSpecifier | UnsupportedSpecifier | UrlSpecifier | VersionSpecifier | WorkspaceProtocolSpecifier;
    function create(instance: Instance, raw: string | Delete): Specifier.Any;
}
