import { Effect } from 'effect';
import { Specifier } from '.';
import { BaseSpecifier } from './base';
import { NonSemverError } from './lib/non-semver-error';
import type { SpecificRegistryResult } from './lib/specific-registry-result';
type T = SpecificRegistryResult<'version'>;
/**
 * An exact semver version
 * @example "1.4.4"
 */
export declare class VersionSpecifier extends BaseSpecifier<T> {
    _tag: string;
    /** Return the semver version */
    getSemver(): Effect.Effect<never, NonSemverError, string>;
    /** Get a new `Specifier` from the given semver version applied to this one */
    setSemver(version: string): Effect.Effect<never, never, Specifier.Any>;
}
export {};
